Module java.net.http
Package java.net.http

# Enum Class HttpClient.Redirect

java.lang.Object
java.lang.Enum<HttpClient.Redirect>
java.net.http.HttpClient.Redirect

All Implemented Interfaces:
  `Serializable`, `Comparable<HttpClient.Redirect>`, `Constable`

Enclosing class:
  HttpClient

public static enum HttpClient.Redirect extends Enum<HttpClient.Redirect>
Defines the automatic redirection policy.

The automatic redirection policy is checked whenever a `3XX` response code is received. If redirection does not happen automatically, then the response, containing the `3XX` response code, is returned, where it can be handled manually.

`Redirect` policy is set through the Builder.followRedirects method.

Implementation Note:
  When automatic redirection occurs, the request method of the redirected request may be modified depending on the specific `30X` status code, as specified in RFC 7231. In addition, the `301` and `302` status codes cause a `POST` request to be converted to a `GET` in the redirected request.
Since:
  11

## Nested Class Summary

## Nested classes/interfaces declared in class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`ALWAYS`
Always redirect.
`NEVER`
Never redirect.
`NORMAL`
Always redirect, except from HTTPS URLs to HTTP URLs.

## Method Summary

Modifier and Type
Method
Description
`static HttpClient.Redirect`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static HttpClient.Redirect[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods declared in class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### NEVER

public static final HttpClient.Redirect NEVER
Never redirect.

### ALWAYS

public static final HttpClient.Redirect ALWAYS
Always redirect.

### NORMAL

public static final HttpClient.Redirect NORMAL
Always redirect, except from HTTPS URLs to HTTP URLs.

## Method Details

### values

public static HttpClient.Redirect[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static HttpClient.Redirect valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null